// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2014 - Scilab Enterprises - Bruno Jofret
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

 
rand("seed", 0);
// grid size
s=150;
// refresh ?
refresh = 50;
// rain delay
rainDelay = 200;

level=zeros(s,s);
vx=zeros(s,s);
vy=zeros(s,s);

up=[2:s, 1];
left=[2:s, 1];
down=[s, 1:s-1];
right=[s, 1:s-1];

figure1 = gcf();

sh = 1:s;
h=zeros(sh);
for i=sh
    for j=sh
        h(i,j) = 1 / (1 + (i - (s / 2))^2 + (j - (s / 2))^2)^2;
    end
end
h=h/sum(h, '*');
szh = size(h);
i=-1;
nd=50;

plot3d(zeros(2*s-1, 2*s-1));
f = gcf();
c = (37:100)';
cyan = [0*c, c, c]/100;
f.color_map = cyan;
a = gca();

a.axes_visible = "off";
a.x_label.visible = "off";
a.y_label.visible = "off";
a.z_label.visible = "off";
a.rotation_angles = [89.75, 60];
a.data_bounds = [0, 0, -0.3 ; 2*s, 2*s, 0.6]
e = gce();
e.color_mode = -4;
e.color_flag = 1;

conv2_1 = [1, 2, 1 ; 2, 10488, 2; 1, 2, 1] ./ 10500;
conv2_2 = [1, 5, 1 ; 5, 6, 5 ; 1, 5, 1] ./ 30;

tic();
for k=1:10000
    i = i + 1;
    if(i == 0 | i > nd)
        nd = floor(nd + rand() * 2000 + rainDelay);
        px = floor(rand() * s)+1;
        py = floor(rand() * s)+1;

        level = level + (rand() * 20 - 10) .* h([px:szh(1), 1:px-1],[py:szh(2) 1:py-1]);
    end

    vx = vx * 0.99998;
    vy = vy * 0.99998;

    graX =   level - level(:,left);
    graY =   level - level(up,:);
    vx = vx + 0.0001 * graX;
    vy = vy + 0.0001 * graY;

    level= level - vy + vy(down,:) -vx +vx(:,right);
    level = conv2(level, conv2_1,'same');

    if(modulo(i, refresh) == 0)
        [XI,YI] = meshgrid(1:0.5:s, 1:0.5:s);
        spl=conv2(level, conv2_1, 'same');
        C = splin2d(1:s, 1:s, spl);
        spl=interp2d(XI, YI, 1:s, 1:s, C);
        e.data.z = spl;
    end
end
toc()
